//+------------------------------------------------------------------+
//|                                                TradeBreakOut.mq4 |
//|                               Copyright  2013, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern int Length=50;
extern int PriceType=0; // Price type
                        // 0 - High/Low
                        // 1 - Close

double Upper[], Lower[];

int init()
  {
   IndicatorShortName("TradeBreakOut oscillator");
   IndicatorDigits(Digits);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Upper);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Lower);
   TimeFrame = MathMax(TimeFrame,_Period);

   return(0);
  }

int deinit()
  {

   return(0);
  }

int start()
{
 if(Bars<=Length) return(0);
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int pos;
 int limit=Bars-2;
 double H, L;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 pos=MathMin(MathMax(limit,3*TimeFrame/_Period),Bars-1);
 while(pos>=0)
 {
  if (PriceType==0)
  {
   int y = iBarShift(NULL,TimeFrame,Time[pos]);
   H=iHigh(NULL,TimeFrame,iHighest(NULL, TimeFrame, MODE_HIGH, Length, y));
   L=iLow(NULL,TimeFrame,iLowest(NULL, TimeFrame, MODE_LOW, Length, y));
   if (L!=0)
   {
    Upper[pos]=(iLow(NULL,TimeFrame,y)-L)/L;
   }
   if (H!=0)
   { 
    Lower[pos]=(iHigh(NULL,TimeFrame,y)-H)/H;
   } 
  }
  else
  {
   H=iClose(NULL,TimeFrame,iHighest(NULL, TimeFrame, MODE_CLOSE, Length, y));
   L=iClose(NULL,TimeFrame,iLowest(NULL, TimeFrame, MODE_CLOSE, Length, y));
   if (L!=0)
   {
    Upper[pos]=(iClose(NULL,TimeFrame,y)-L)/L;
   }
   if (H!=0)
   { 
    Lower[pos]=(iClose(NULL,TimeFrame,y)-H)/H;
   } 
  }
  pos--;
 }

 return(0);
}

